<?php
/**
 * InlineResponse20024Employees
 *
 * PHP version 7.3
 *
 * @category Class
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * TANSS API
 *
 * ## Documentation of the TANSS API. Version: 5.8.22.1  ### older versions Older versions of the API documentation can be found here: * [Docs for 5.8.21.6](https://api-doc.tanss.de/5.8.21.6/) * [Docs for 5.8.21.3](https://api-doc.tanss.de/5.8.21.3/) * [Docs for 5.8.21.1](https://api-doc.tanss.de/5.8.21.1/) * [Docs for 5.8.20.5](https://api-doc.tanss.de/5.8.20.5/) * [Docs for 5.8.20.4](https://api-doc.tanss.de/5.8.20.4/) * [Docs for 5.8.20.2](https://api-doc.tanss.de/5.8.20.2/) * [Docs for 5.8.19.3](https://api-doc.tanss.de/5.8.19.3/)
 *
 * The version of the OpenAPI document: 5.8.22.1
 * Contact: support@tanss.de
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 6.0.0-SNAPSHOT
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace SLIS\Adapter\Tanss\Model;

use \ArrayAccess;
use \SLIS\Adapter\Tanss\ObjectSerializer;

/**
 * InlineResponse20024Employees Class Doc Comment
 *
 * @category Class
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 * @implements \ArrayAccess<TKey, TValue>
 * @template TKey int|null
 * @template TValue mixed|null
 */
class InlineResponse20024Employees implements ModelInterface, ArrayAccess, \JsonSerializable
{
    public const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'inline_response_200_24_employees';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'id' => 'int',
        'name' => 'string',
        'salutation' => 'string',
        'title' => 'string',
        'firstName' => 'string',
        'lastName' => 'string',
        'email' => 'string',
        'phoneNumber1' => 'string',
        'phoneNumber2' => 'string',
        'mobileNumber1' => 'string',
        'mobileNumber2' => 'string',
        'faxNumber' => 'string',
        'room' => 'string',
        'initials' => 'string',
        'function' => 'string',
        'active' => 'bool',
        'externalId' => 'string',
        'assignedToCustomers' => '\SLIS\Adapter\Tanss\Model\InlineResponse20024AssignedToCustomers[]',
        'preferredCustomer' => '\SLIS\Adapter\Tanss\Model\InlineResponse20024PreferredCustomer'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      * @phpstan-var array<string, string|null>
      * @psalm-var array<string, string|null>
      */
    protected static $openAPIFormats = [
        'id' => null,
        'name' => null,
        'salutation' => null,
        'title' => null,
        'firstName' => null,
        'lastName' => null,
        'email' => null,
        'phoneNumber1' => null,
        'phoneNumber2' => null,
        'mobileNumber1' => null,
        'mobileNumber2' => null,
        'faxNumber' => null,
        'room' => null,
        'initials' => null,
        'function' => null,
        'active' => null,
        'externalId' => null,
        'assignedToCustomers' => null,
        'preferredCustomer' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'id' => 'id',
        'name' => 'name',
        'salutation' => 'salutation',
        'title' => 'title',
        'firstName' => 'first_name',
        'lastName' => 'last_name',
        'email' => 'email',
        'phoneNumber1' => 'phone_number_1',
        'phoneNumber2' => 'phone_number_2',
        'mobileNumber1' => 'mobile_number_1',
        'mobileNumber2' => 'mobile_number_2',
        'faxNumber' => 'fax_number',
        'room' => 'room',
        'initials' => 'initials',
        'function' => 'function',
        'active' => 'active',
        'externalId' => 'external_id',
        'assignedToCustomers' => 'assigned_to_customers',
        'preferredCustomer' => 'preferred_customer'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'id' => 'setId',
        'name' => 'setName',
        'salutation' => 'setSalutation',
        'title' => 'setTitle',
        'firstName' => 'setFirstName',
        'lastName' => 'setLastName',
        'email' => 'setEmail',
        'phoneNumber1' => 'setPhoneNumber1',
        'phoneNumber2' => 'setPhoneNumber2',
        'mobileNumber1' => 'setMobileNumber1',
        'mobileNumber2' => 'setMobileNumber2',
        'faxNumber' => 'setFaxNumber',
        'room' => 'setRoom',
        'initials' => 'setInitials',
        'function' => 'setFunction',
        'active' => 'setActive',
        'externalId' => 'setExternalId',
        'assignedToCustomers' => 'setAssignedToCustomers',
        'preferredCustomer' => 'setPreferredCustomer'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'id' => 'getId',
        'name' => 'getName',
        'salutation' => 'getSalutation',
        'title' => 'getTitle',
        'firstName' => 'getFirstName',
        'lastName' => 'getLastName',
        'email' => 'getEmail',
        'phoneNumber1' => 'getPhoneNumber1',
        'phoneNumber2' => 'getPhoneNumber2',
        'mobileNumber1' => 'getMobileNumber1',
        'mobileNumber2' => 'getMobileNumber2',
        'faxNumber' => 'getFaxNumber',
        'room' => 'getRoom',
        'initials' => 'getInitials',
        'function' => 'getFunction',
        'active' => 'getActive',
        'externalId' => 'getExternalId',
        'assignedToCustomers' => 'getAssignedToCustomers',
        'preferredCustomer' => 'getPreferredCustomer'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }


    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['id'] = $data['id'] ?? null;
        $this->container['name'] = $data['name'] ?? null;
        $this->container['salutation'] = $data['salutation'] ?? null;
        $this->container['title'] = $data['title'] ?? null;
        $this->container['firstName'] = $data['firstName'] ?? null;
        $this->container['lastName'] = $data['lastName'] ?? null;
        $this->container['email'] = $data['email'] ?? null;
        $this->container['phoneNumber1'] = $data['phoneNumber1'] ?? null;
        $this->container['phoneNumber2'] = $data['phoneNumber2'] ?? null;
        $this->container['mobileNumber1'] = $data['mobileNumber1'] ?? null;
        $this->container['mobileNumber2'] = $data['mobileNumber2'] ?? null;
        $this->container['faxNumber'] = $data['faxNumber'] ?? null;
        $this->container['room'] = $data['room'] ?? null;
        $this->container['initials'] = $data['initials'] ?? null;
        $this->container['function'] = $data['function'] ?? null;
        $this->container['active'] = $data['active'] ?? null;
        $this->container['externalId'] = $data['externalId'] ?? null;
        $this->container['assignedToCustomers'] = $data['assignedToCustomers'] ?? null;
        $this->container['preferredCustomer'] = $data['preferredCustomer'] ?? null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets id
     *
     * @return int|null
     */
    public function getId()
    {
        return $this->container['id'];
    }

    /**
     * Sets id
     *
     * @param int|null $id id
     *
     * @return self
     */
    public function setId($id)
    {
        $this->container['id'] = $id;

        return $this;
    }

    /**
     * Gets name
     *
     * @return string|null
     */
    public function getName()
    {
        return $this->container['name'];
    }

    /**
     * Sets name
     *
     * @param string|null $name name
     *
     * @return self
     */
    public function setName($name)
    {
        $this->container['name'] = $name;

        return $this;
    }

    /**
     * Gets salutation
     *
     * @return string|null
     */
    public function getSalutation()
    {
        return $this->container['salutation'];
    }

    /**
     * Sets salutation
     *
     * @param string|null $salutation salutation
     *
     * @return self
     */
    public function setSalutation($salutation)
    {
        $this->container['salutation'] = $salutation;

        return $this;
    }

    /**
     * Gets title
     *
     * @return string|null
     */
    public function getTitle()
    {
        return $this->container['title'];
    }

    /**
     * Sets title
     *
     * @param string|null $title title
     *
     * @return self
     */
    public function setTitle($title)
    {
        $this->container['title'] = $title;

        return $this;
    }

    /**
     * Gets firstName
     *
     * @return string|null
     */
    public function getFirstName()
    {
        return $this->container['firstName'];
    }

    /**
     * Sets firstName
     *
     * @param string|null $firstName firstName
     *
     * @return self
     */
    public function setFirstName($firstName)
    {
        $this->container['firstName'] = $firstName;

        return $this;
    }

    /**
     * Gets lastName
     *
     * @return string|null
     */
    public function getLastName()
    {
        return $this->container['lastName'];
    }

    /**
     * Sets lastName
     *
     * @param string|null $lastName lastName
     *
     * @return self
     */
    public function setLastName($lastName)
    {
        $this->container['lastName'] = $lastName;

        return $this;
    }

    /**
     * Gets email
     *
     * @return string|null
     */
    public function getEmail()
    {
        return $this->container['email'];
    }

    /**
     * Sets email
     *
     * @param string|null $email email
     *
     * @return self
     */
    public function setEmail($email)
    {
        $this->container['email'] = $email;

        return $this;
    }

    /**
     * Gets phoneNumber1
     *
     * @return string|null
     */
    public function getPhoneNumber1()
    {
        return $this->container['phoneNumber1'];
    }

    /**
     * Sets phoneNumber1
     *
     * @param string|null $phoneNumber1 phoneNumber1
     *
     * @return self
     */
    public function setPhoneNumber1($phoneNumber1)
    {
        $this->container['phoneNumber1'] = $phoneNumber1;

        return $this;
    }

    /**
     * Gets phoneNumber2
     *
     * @return string|null
     */
    public function getPhoneNumber2()
    {
        return $this->container['phoneNumber2'];
    }

    /**
     * Sets phoneNumber2
     *
     * @param string|null $phoneNumber2 phoneNumber2
     *
     * @return self
     */
    public function setPhoneNumber2($phoneNumber2)
    {
        $this->container['phoneNumber2'] = $phoneNumber2;

        return $this;
    }

    /**
     * Gets mobileNumber1
     *
     * @return string|null
     */
    public function getMobileNumber1()
    {
        return $this->container['mobileNumber1'];
    }

    /**
     * Sets mobileNumber1
     *
     * @param string|null $mobileNumber1 mobileNumber1
     *
     * @return self
     */
    public function setMobileNumber1($mobileNumber1)
    {
        $this->container['mobileNumber1'] = $mobileNumber1;

        return $this;
    }

    /**
     * Gets mobileNumber2
     *
     * @return string|null
     */
    public function getMobileNumber2()
    {
        return $this->container['mobileNumber2'];
    }

    /**
     * Sets mobileNumber2
     *
     * @param string|null $mobileNumber2 mobileNumber2
     *
     * @return self
     */
    public function setMobileNumber2($mobileNumber2)
    {
        $this->container['mobileNumber2'] = $mobileNumber2;

        return $this;
    }

    /**
     * Gets faxNumber
     *
     * @return string|null
     */
    public function getFaxNumber()
    {
        return $this->container['faxNumber'];
    }

    /**
     * Sets faxNumber
     *
     * @param string|null $faxNumber faxNumber
     *
     * @return self
     */
    public function setFaxNumber($faxNumber)
    {
        $this->container['faxNumber'] = $faxNumber;

        return $this;
    }

    /**
     * Gets room
     *
     * @return string|null
     */
    public function getRoom()
    {
        return $this->container['room'];
    }

    /**
     * Sets room
     *
     * @param string|null $room room
     *
     * @return self
     */
    public function setRoom($room)
    {
        $this->container['room'] = $room;

        return $this;
    }

    /**
     * Gets initials
     *
     * @return string|null
     */
    public function getInitials()
    {
        return $this->container['initials'];
    }

    /**
     * Sets initials
     *
     * @param string|null $initials initials
     *
     * @return self
     */
    public function setInitials($initials)
    {
        $this->container['initials'] = $initials;

        return $this;
    }

    /**
     * Gets function
     *
     * @return string|null
     */
    public function getFunction()
    {
        return $this->container['function'];
    }

    /**
     * Sets function
     *
     * @param string|null $function function
     *
     * @return self
     */
    public function setFunction($function)
    {
        $this->container['function'] = $function;

        return $this;
    }

    /**
     * Gets active
     *
     * @return bool|null
     */
    public function getActive()
    {
        return $this->container['active'];
    }

    /**
     * Sets active
     *
     * @param bool|null $active active
     *
     * @return self
     */
    public function setActive($active)
    {
        $this->container['active'] = $active;

        return $this;
    }

    /**
     * Gets externalId
     *
     * @return string|null
     */
    public function getExternalId()
    {
        return $this->container['externalId'];
    }

    /**
     * Sets externalId
     *
     * @param string|null $externalId externalId
     *
     * @return self
     */
    public function setExternalId($externalId)
    {
        $this->container['externalId'] = $externalId;

        return $this;
    }

    /**
     * Gets assignedToCustomers
     *
     * @return \SLIS\Adapter\Tanss\Model\InlineResponse20024AssignedToCustomers[]|null
     */
    public function getAssignedToCustomers()
    {
        return $this->container['assignedToCustomers'];
    }

    /**
     * Sets assignedToCustomers
     *
     * @param \SLIS\Adapter\Tanss\Model\InlineResponse20024AssignedToCustomers[]|null $assignedToCustomers assignedToCustomers
     *
     * @return self
     */
    public function setAssignedToCustomers($assignedToCustomers)
    {
        $this->container['assignedToCustomers'] = $assignedToCustomers;

        return $this;
    }

    /**
     * Gets preferredCustomer
     *
     * @return \SLIS\Adapter\Tanss\Model\InlineResponse20024PreferredCustomer|null
     */
    public function getPreferredCustomer()
    {
        return $this->container['preferredCustomer'];
    }

    /**
     * Sets preferredCustomer
     *
     * @param \SLIS\Adapter\Tanss\Model\InlineResponse20024PreferredCustomer|null $preferredCustomer preferredCustomer
     *
     * @return self
     */
    public function setPreferredCustomer($preferredCustomer)
    {
        $this->container['preferredCustomer'] = $preferredCustomer;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset): bool
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed|null
     */
    #[\ReturnTypeWillChange]
    public function offsetGet($offset)
    {
        return $this->container[$offset] ?? null;
    }

    /**
     * Sets value based on offset.
     *
     * @param int|null $offset Offset
     * @param mixed    $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value): void
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset): void
    {
        unset($this->container[$offset]);
    }

    /**
     * Serializes the object to a value that can be serialized natively by json_encode().
     * @link https://www.php.net/manual/en/jsonserializable.jsonserialize.php
     *
     * @return mixed Returns data which can be serialized by json_encode(), which is a value
     * of any type other than a resource.
     */
    #[\ReturnTypeWillChange]
    public function jsonSerialize()
    {
       return ObjectSerializer::sanitizeForSerialization($this);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


